mount -o rw,remount /data
MODDIR=${0%/*}

# etc
if [ -d /sbin/.magisk ]; then
  MAGISKTMP=/sbin/.magisk
else
  MAGISKTMP=`find /dev -mindepth 2 -maxdepth 2 -type d -name .magisk`
fi
ETC=$MAGISKTMP/mirror/system/etc
VETC=$MAGISKTMP/mirror/vendor/etc
MODETC=$MODDIR/system/etc
MODVETC=$MODDIR/system/vendor/etc

# conflict
AML=/data/adb/modules/aml
ACDB=/data/adb/modules/acdb
if [ -d $AML ] && [ -d $ACDB ]; then
  rm -rf $ACDB
fi

# audio effects
FILE=*audio*effects*
rm -f `find $MODDIR/system -type f -name $FILE`
if [ ! -d $ACDB ] || [ -f $ACDB/disable ]; then
  AEC=`find $ETC -maxdepth 1 -type f -name $FILE.conf`
  VAEC=`find $VETC -maxdepth 1 -type f -name $FILE.conf`
  AEX=`find $ETC -maxdepth 1 -type f -name $FILE.xml`
  VAEX=`find $VETC -maxdepth 1 -type f -name $FILE.xml`
  cp -f $AEC $MODETC
  cp -f $VAEC $MODVETC
  cp -f $AEX $MODETC
  cp -f $VAEX $MODVETC
fi

# media codecs
FILE=media_codecs.xml
rm -f $MODVETC/$FILE
FOLDER=$AML/system/vendor/etc
if [ -d $FOLDER ]; then
  cp -f $VETC/$FILE $FOLDER
else
  cp -f $VETC/$FILE $MODVETC
fi

# run
sh $MODDIR/.aml.sh

# context
FILE=$MODDIR/system/vendor/bin/hw/*dms*
chcon u:object_r:hal_dms_default_exec:s0 $FILE

# directory
DIR=/data/vendor/dolby
if [ ! -d $DIR ]; then
  mkdir -p $DIR
fi
chmod 0770 $DIR
chown 1013.1013 $DIR
chcon u:object_r:vendor_data_file:s0 $DIR

# cleaning
FILE=$MODDIR/cleaner.sh
if [ -f $FILE ]; then
  sh $FILE
  rm -f $FILE
fi









